#include "printcomments.h"

int state = 1;

char *buffer = 0;

int hwm = 0;
int bufflen = 0;



/* System Under Test fuer Anwendung der W-Methode */


extern void action(int actionId);

void ignore(void) {

    action(ignoreAction);

}


void reset(void) {

    action(resetAction);

    hwm = 0;
}

void cat(int c) {

    action(catAction);

    buffer[hwm++] = (char)c;

}


void truncatex(void) {

    action(truncateAction);

    hwm--;

}



int handleState1(int c) { 
	 
    switch ( c ) {

	case '/': 
	    ignore();
	    return 2;

	default:
	    ignore();
	    return state;

    }

}

int handleState2(int c) { 
	 
    switch ( c ) {

	case '*':
	    reset();
	    return 3;

	case '/': 
	default:
	    ignore();
	    return 2;

    }

}


int handleState3(int c) { 
	 
    switch ( c ) {

	case '*':
	    cat(c);
	    return 4;

	case '/': 
	default:
            cat(c);
	    return 3;

    }

}

int handleState4(int c) { 
	 
    switch ( c ) {

	case '*':
	    cat(c);
	    return 4;

	case '/': 
	    truncatex();
	    print();
	    return 1;

	default:
	    cat(c);
	    return 3;

    }

}



void mealyAutomaton(int c) {

    /* Check if we need more buffer
       (this works also for empty buffer) */
    if ( hwm == bufflen ) {
	buffer = (char *)realloc(buffer,bufflen + BUFFER_CHUNK);
	bufflen += BUFFER_CHUNK;
    }

    /*-- Now process the state machine --*/
    switch (state) {

	case 1:
	    state = handleState1(c);
	    break;

	case 2:
	    state = handleState2(c);
	    break;

	case 3:
	    state = handleState3(c);
	    break;

	case 4:
	    state = handleState4(c);
	    break;

	default:
	    printf("Illegal state.\n");
	    exit(1);

    }



}

